import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class FlappyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlappyWorld extends World
{
    int pipeCounter = 0;
    int flappyCounter = 0;
    double SPACE_BETWEEN_PIPES = 120;
    int score = 0;
    int FIRST_PIPE = 200;
    Score scoreCount = null;
    FlappyBird flappyBird = null;
    PenguinTitle penguinTitle = null;
    PlayButton play = null;
    CoinCount coinCount = null;
    boolean isPaused = true;
    GreenfootSound honk = new GreenfootSound("Honk.mp3");
    
    
    
    /**
     * Constructor for objects of class FlappyWorld.
     * 
     */
    public FlappyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1, false); 
        
        FlappyBird flappy = new FlappyBird();
        addObject (flappy, getWidth()/6, getHeight()/2);
        
        scoreCount = new Score();
        scoreCount.setScore(0);
        addObject(scoreCount, getWidth()/2, getHeight()/6);
        
        Ground ground = new Ground();
        addObject (ground, getWidth()/2, (int) (getHeight() +5));
        
        PenguinTitle penguinTitle = new PenguinTitle();
        addObject (penguinTitle, getWidth()/2, getHeight()*1/3);
        
        Instructions instructions = new Instructions();
        addObject (instructions, getWidth()/2, getHeight()*3/4);
        
        
        CoinCount coinCount = new CoinCount();
        addObject(coinCount, getWidth()*5/8, getHeight()/9);
        
        setPaintOrder(GameOver.class, FlappyBird.class, PenguinTitle.class, Score.class, Instructions.class, TopPipe.class, BottomPipe.class, Seal.class, Coin. class, Ground.class);
    }
    
    
    private void createPipes () {
        BottomPipe pippy = new BottomPipe();
        GreenfootImage image = pippy.getImage();
        addObject(pippy, getWidth(), getHeight()/2 + image.getHeight() - Greenfoot.getRandomNumber(200));
        TopPipe pipster = new TopPipe();
        addObject(pipster, getWidth(), (int) ( pippy.getY() - image.getHeight() - SPACE_BETWEEN_PIPES ));
        
        if (Greenfoot.getRandomNumber(11) >= 9) {
            Coin coin = new Coin();
            addObject(coin, getWidth(), (int) (Greenfoot.getRandomNumber(getHeight())));
        }
        if (Greenfoot.getRandomNumber(21) >= 19) {
            Seal seal = new Seal();
            addObject(seal, getWidth(), (int) (Greenfoot.getRandomNumber(getHeight())));
        }
    }
    public CoinCount getCoinCount() {
        return coinCount;
    }
    public void act() {
      
        pipeCounter++;
        
        if (pipeCounter % 100 == 0) {
            createPipes();
            
        }
        if (pipeCounter >= FIRST_PIPE) {
            if (flappyCounter % 100 == 0) {
                score++;
                scoreCount.setScore(score);
                
            }
            flappyCounter++;
        
        }
        
        if (Greenfoot.isKeyDown("space")) {
            honk.play();
        }
        
        
    }
    public Score getScore() {
        return scoreCount;
    }
}
